%%  lda -    
%%  :
%%  train_features -   
%  ( mxn (n  () m-  ),
%      n      

%    - m  -> m-  ,
%   n m-  (n  () )

%     -   
%   ,       m-
%      :
%    y=w'*x - ,       
%  :
%  n/2   1-  -  "p300"
%  n/2   1-  -  "no_p300"

%% group -   
% (: 1 -  "p300", 0 -  "no_p300")

%% test_features -  
%  ( mxn (n  () m-  ),
%      

%%  :
%%  classes ( nx1) 
%  ,       
%    n   
%  (: 1 -  "p300", 0 -  "no_p300")

%  y1 -      w (group==1)
%  y2 -      w (group==0)
%  test_y -      w
%  center -  

%%
function [classes,y1,y2,test_y,center] = lda(train_features, group, test_features)

%% train_features mxn (n  m-  )
c1=find(group==1); 
c2=find(group==0);
train_c1=train_features(:,c1);
train_c2=train_features(:,c2);

%% classes means
mean1=mean(train_c1,2); %  80-  ( n   1)
mean2=mean(train_c2,2); %  80-  ( n   2)
S1=cov(train_c1');      %   80x80  80- 
S2=cov(train_c2');

%% within-class scatter matrix  (  )
Sw = S1+S2;

%% between-class scatter matrix (  )
Sb = (mean1-mean2)*(mean1-mean2)';

%%   w (y=w'*x)
% w = inv(Sw)*(mean1-mean2);
w = pinv(Sw)*(mean1-mean2);

%      w
y1=w'*train_c1; y2=w'*train_c2;

%%  
m1=mean(y1); m2=mean(y2);
cp=abs((m1-m2)/2);
if (m1<m2)
    center=m1+cp; work=1; belowthres=1; afterthres=0;
elseif (m1==m2)
    center=m1;    work=0;
elseif (m1>m2)
    center=m2+cp; work=1; belowthres=0; afterthres=1;
end

%%   
%         w
test_y=w'*test_features;
class1=find(test_y>center); 
class2=find(test_y<center);
class0=find(test_y==center);

%     
classes=zeros(1,size(test_features,2));

if (work==1) %    
    classes(1,class1)=afterthres;
    classes(1,class2)=belowthres;
    classes(1,class0)=100;
elseif (work==0) %    ( )
    classes(:,:)=100;
end


end